package net.sf.brunneng.fusie.core

import scala.collection.mutable.HashMap



/**
 * User: goodg_000
 * Date: 30.03.13
 * Time: 20:11
 */
class Context {

  var variableValues = new HashMap[String, ProbableValue[Any]]

  def get(varName: String): ProbableValue[Any] = {
    variableValues(varName)
  }

  def contains(varName: String): Boolean = {
    variableValues.contains(varName)
  }

  def set(varName: String, value: ProbableValue[Any]) {
    variableValues(varName) = value
  }

  def hasKeyConflictsWith(other: Context): Boolean = hasConflictsWith(other, checkValues = false)
  def hasKeyValueConflictsWith(other: Context): Boolean = hasConflictsWith(other, checkValues = true)

  private def hasConflictsWith(other : Context, checkValues: Boolean): Boolean = {
    val otherValues = other.variableValues
    variableValues.find(pair => otherValues.contains(pair._1) &&
      (!checkValues || !otherValues(pair._1).equalValue(pair._2))).isDefined
  }

  def copy: Context = {
    val res = new Context()
    val resValues = res.variableValues
    resValues ++= variableValues
    res
  }
}
