package net.sf.brunneng.fusie.core

import scala.collection.mutable.HashMap
import scala.collection.mutable

/**
 * User: goodg_000
 * Date: 04.04.13
 * Time: 0:22
 */
class Environment {
  val contextsStack = new mutable.Stack[Context]

  def currentContext: Context = contextsStack.top

  def get(varName : String) : ProbableValue[Any] = {
    currentContext.get(varName)
  }

  def set(varName : String, value : Any) {
    currentContext.set(varName, new ProbableValue[Any](value, null))
  }

  def setInAllContexts(varName : String, value : Any) {
    contextsStack.foreach(c => c.set(varName, new ProbableValue[Any](value, null)))
  }

  def set(varName : String, value : ProbableValue[Any]) {
    currentContext.set(varName, value)
  }

  def contains(varName : String): Boolean = currentContext.variableValues.contains(varName)

  def pushContext(context : Context) {
    contextsStack.push(context)
  }

  def popContext() {
    contextsStack.pop()
  }
}
