package net.sf.brunneng.fusie.core

/**
 * User: goodg_000
 * Date: 31.03.13
 * Time: 18:43
 */
class InferenceResult[T](val value : T, var probability : Double) {

  def equalValue(other : InferenceResult[T]) : Boolean = {
    if (value.isInstanceOf[Double]) {
      val v1 = value.asInstanceOf[Double]
      val v2 = other.value.asInstanceOf[Double]
      scala.math.abs(v1 - v2) < Constants.EPSILON
    }

    value.equals(other.value)
  }

  override def equals(that: Any) = {
    that match {
      case pv: InferenceResult[T] => equalValue(pv) && scala.math.abs(probability - pv.probability) < Constants.EPSILON
      case _ => false
    }
  }

  override def hashCode(): Int = value.hashCode + 31*probability.hashCode()

  override def toString: String = "value: " + value + " (prob: " + probability + ")"
}
