package net.sf.brunneng.fusie.core

/**
 * User: goodg_000
 * Date: 30.03.13
 * Time: 20:58
 */
class Variable[T](val varName : String, var clazz : Class[T]) {

  var env : Environment = null

  def isDefined = env.contains(varName)
  def probableValue : ProbableValue[T] = env.get(varName).asInstanceOf[ProbableValue[T]]

  def setValue(value : T) {
    env.set(varName, value)
  }

  override def toString: String = "Variable(name=" + varName + ", class=" + clazz.getSimpleName + ")"
}
