package net.sf.brunneng.fusie.core.expressions

import net.sf.brunneng.fusie.core.Variable
import collection.mutable.ListBuffer

/**
 * User: goodg_000
 * Date: 30.03.13
 * Time: 0:13
 */
abstract class Expression[+T] {
  def calculate : T

  def collectVariables(res : ListBuffer[Variable[Any]])

  def getChildExpressions : List[Expression[Any]]

  def filterExpressions(predicate : (Expression[Any] => Boolean)): List[Expression[Any]] = {
    def filterExpressionsInternal(e: Expression[Any], collector: ListBuffer[Expression[Any]]) {
      if (predicate(e)) collector += e
      e.getChildExpressions.foreach(ce => filterExpressionsInternal(ce, collector))
    }

    val res = new ListBuffer[Expression[Any]]
    filterExpressionsInternal(this, res)
    res.toList
  }

  def getProbabilityExpression: Expression[Boolean]

  def getAllVariables : List[Variable[Any]] = {
    val res = new ListBuffer[Variable[Any]]()
    collectVariables(res)
    res.toList
  }
}
