package net.sf.brunneng.fusie.core.expressions

import net.sf.brunneng.fusie.core.Variable
import collection.mutable.ListBuffer

/**
 * Function on 1 expression.
 *
 * User: goodg_000
 * Date: 30.03.13
 * Time: 19:52
 */
class F1Expression[TV1, T](
  val expr1 : Expression[TV1], val func : TV1 => T, val funcName : String) extends Expression[T] {

  def calculate: T = func(expr1.calculate)

  def collectVariables(res : ListBuffer[Variable[Any]]) {
    expr1.collectVariables(res)
  }

  def getProbabilityExpression: Expression[Boolean] = {
    val probExpr1 = expr1.getProbabilityExpression
    funcName match {
      case "!" => F1ExpressionFactory.notNullSafe(probExpr1)
      case _ => probExpr1
    }
  }

  def getChildExpressions: List[Expression[Any]] = List(expr1)

  override def toString: String = "F1Expression(" + funcName + expr1.toString + ")"
}
