package net.sf.brunneng.fusie.core.expressions

/**
 * User: goodg_000
 * Date: 31.03.13
 * Time: 0:45
 */
object F1ExpressionFactory {

  // Numeric operations ################################################################################################
  def negate[T](expr1 : Expression[T])(implicit numeric: Numeric[T]) : Expression[T] = {
    new F1Expression[T, T](expr1, v => numeric.negate(v), "-")
  }

  def castToDouble[T](expr1 : Expression[T])(implicit numeric: Numeric[T]) : Expression[Double] = {
    new F1Expression[T, Double](expr1, v => numeric.toDouble(v), "(double)")
  }

  // Boolean operations ################################################################################################
  def not(expr1 : Expression[Boolean]) : Expression[Boolean] = {
    new F1Expression[Boolean, Boolean](expr1, v => !v, "!")
  }

  def notNullSafe(expr1 : Expression[Boolean]) : Expression[Boolean] = {
    if (expr1 == null)
      null
    else
      new F1Expression[Boolean, Boolean](expr1, v => !v, "!")
  }
}
