package net.sf.brunneng.fusie.core.expressions

import java.lang.reflect.Method
import scala.collection.mutable.ListBuffer
import net.sf.brunneng.fusie.core.Variable

/**
 * Created with IntelliJ IDEA.
 * User: evvo
 * Date: 5/21/13
 * Time: 11:49 AM
 * To change this template use File | Settings | File Templates.
 */
class FnReflectionExpression[T](val name: String, expressions: List[Expression[_]],
                                obj: Object, m: Method) extends Expression[T] {

  def calculate: T = {
    val args: Array[Object] = expressions.map(e => e.calculate).toArray.asInstanceOf[Array[Object]]
    m.invoke(obj, args: _*).asInstanceOf[T]
  }

  def collectVariables(res: ListBuffer[Variable[Any]]) {
    expressions.foreach(e => e.collectVariables(res))
  }

  def getChildExpressions: List[Expression[Any]] = expressions

  def getProbabilityExpression: Expression[Boolean] = {
    if (expressions.isEmpty)
      new ValueExpression[Boolean](true)
    else
      expressions.tail.foldLeft(expressions.head.getProbabilityExpression)((curr, next) =>
        F2ExpressionFactory.andNullSafe(curr, next.getProbabilityExpression))
  }
}
