package net.sf.brunneng.fusie.core.expressions

import net.sf.brunneng.fusie.core.{Variable}
import collection.mutable.ListBuffer

/**
 * User: goodg_000
 * Date: 30.03.13
 * Time: 20:35
 */
class VariableExpression[T](val variable : Variable[T])
  extends Expression[T] {

  def calculate: T = variable.probableValue.value

  def collectVariables(res : ListBuffer[Variable[Any]]) {
    res += variable.asInstanceOf[Variable[Any]]
  }

  def getChildExpressions: List[Expression[Any]] = List()

  def getProbabilityExpression: Expression[Boolean] = variable.probableValue.probability

  override def toString: String = "VariableExpression(" + variable + ")"
}
