package net.sf.brunneng.fusie.engine

import scala.collection.mutable
import net.sf.brunneng.fusie.core.{Environment, Rule, Variable}

/**
 * User: goodg_000
 * Date: 05.04.13
 * Time: 0:19
 */
class InferenceEngineInput(private val userDefinedVarNames: List[String],
                           val variables: List[Variable[Any]],
                           val rules: List[Rule], val goalVariableName : String,
                           var variableValuesSource: VariableValuesSource) {

  def readRequiredVariables() {
    if (variableValuesSource != null) {
      userDefinedVarNames.map(varName => getVariableByName(varName)).foreach(
        v => if (variableValuesSource.isRequired(v)) {
          v.setValue(variableValuesSource.read(v))
        })
    }
  }

  private def getVariableByName(varName: String): Variable[Any] = {
    variables.find(v => v.varName.equals(varName)).get
  }

  def getIndexInDefined(varName: String): Int = {
    userDefinedVarNames.indexOf(varName)
  }

  def getVariableValue(varName : String) : Any = {
    val v = variables.find(v => v.varName.equals(varName)).getOrElse(null)
    variableValuesSource.read(v)
  }


}
