package net.sf.brunneng.fusie.examples

import net.sf.brunneng.fusie.input.pdl.PDLParser
import net.sf.brunneng.fusie.ui.ConsoleUserInteraction
import net.sf.brunneng.fusie.engine.fcf.FCFInferenceEngine
import java.util.Scanner
import scala.collection.mutable.StringBuilder
import java.io.File
import net.sf.brunneng.fusie.input.HashMapValuesSource

/**
 * Created with IntelliJ IDEA.
 * User: evvo
 * Date: 5/17/13
 * Time: 12:41 PM
 * To change this template use File | Settings | File Templates.
 */
object FileInputExample {

  def main(args: Array[String]) {
    if (args.length == 0) {
      throw new Exception("Path to file should be set!")
    }

    val pathToFile = args(0)
    val s = new Scanner(new File(pathToFile))
    val sb = new StringBuilder
    while (s.hasNextLine) {
      sb.append(s.nextLine()).append("\n")
    }
    val fileContent = sb.toString()

//    val input = new PDLParser().parseProblem(fileContent, new ConsoleUserInteraction)

//    val input = new PDLParser().parseProblem(fileContent)
//    input.variableValuesSource =new HashMapValuesSource(Map(
//      "loanAmount" -> 10000,
//      "collateralValue" -> 20000,
//      "useOfFounds" -> "PurchaseExistingBusiness",
//      "grossSales" -> 10000,
//      "netProfit" -> 4000,
//      "cashBalance" -> 10000,
//      "customerType" -> "GovernmentAgencies",
//      "numberOfEmployees" -> 200,
//      "personalGuarantee" -> true
//    ).asInstanceOf[Map[String, Object]])

    val input = new PDLParser().parseProblem(fileContent)
    input.variableValuesSource = new HashMapValuesSource(Map(
      "loanAmount" -> 10000,
      "collateralValue" -> 10000,
      "useOfFounds" -> "PurchaseExistingBusiness",
      "grossSales" -> 10000,
      "netProfit" -> 1000,
      "cashBalance" -> 10000,
      "customerType" -> "SmallBusiness",
      "numberOfEmployees" -> 5,
      "personalGuarantee" -> false
    ).asInstanceOf[Map[String, Object]])

    println(new FCFInferenceEngine().run(input))
  }
}
