package net.sf.brunneng.fusie.examples

import net.sf.brunneng.fusie.input.pdl.PDLParser
import net.sf.brunneng.fusie.ui.ConsoleUserInteraction
import net.sf.brunneng.fusie.engine.fcf.FCFInferenceEngine

/**
 * User: goodg_000
 * Date: 05.05.13
 * Time: 17:43
 */
object FinancialAdviser {
  def main(args: Array[String]) {
    val input = new PDLParser().parseProblem(
      """int amountSaved <- "How many savings you have?"
        |int earnings <- "What is you year income?"
        |bool steady <- "Your year income is stable?"
        |int dependents = min: 0 <- "How many dependents you have?"
        |
        |fact
        |   minincome = 15000 + (4000 * dependents)
        |
        |fact
        |   minsavings = 5000 * dependents
        |
        |when
        |   savingsAccount == "inadequate"
        |then
        |   investment = "savings"
        |
        |when
        |   (savingsAccount == "adequate") && (income == "adequate")
        |then
        |   investment = "stocks"
        |
        |when
        |   savingsAccount == "adequate"
        |   income == "inadequate"
        |then
        |   investment = "combination"
        |
        |when
        |   amountSaved > minsavings
        |then
        |   savingsAccount = "adequate"
        |
        |when
        |   amountSaved <= minsavings
        |then
        |   savingsAccount = "inadequate"
        |
        |when
        |   steady
        |   earnings > minincome
        |then
        |   income = "adequate"
        |
        |when
        |   steady
        |   earnings <= minincome
        |then
        |   income = "inadequate"
        |
        |when
        |   !steady
        |then
        |   income = "inadequate"
        |
        |find investment""".stripMargin, null, new ConsoleUserInteraction)
    println(new FCFInferenceEngine().run(input))
  }
}
