package net.sf.brunneng.fusie.examples

import net.sf.brunneng.fusie.input.pdl.PDLParser
import net.sf.brunneng.fusie.ui.ConsoleUserInteraction
import net.sf.brunneng.fusie.engine.fcf.FCFInferenceEngine

/**
 * Created with IntelliJ IDEA.
 * User: evvo
 * Date: 5/17/13
 * Time: 9:44 AM
 * To change this template use File | Settings | File Templates.
 */
object LoanarAdvicer {
  def main(args: Array[String]) {
    val input = new PDLParser().parseProblem(
      """int loanAmount = min: 0 <- "What is loan amount? ($)"
        |int collateralValue = min: 0 <- "What is your collateral value? ($)"
        |enum useOfFounds = PurchaseExistingBusiness ("Purchase Existing Business") | PurchaseSellInventory ("Purchase Sell Inventory") | FinanceReceivables ("Finance Receivables") | GeneralCreditLine ("General Credit Line") <- "What is use of founds?"
        |int grossSales = min: 0 <- "What is your gross sales? ($)"
        |int netProfit <- "What is your net profit? ($)"
        |int cashBalance <- "What is your cash balance? ($)"
        |enum customerType = SmallBusiness ("Small Business") | GovernmentAgencies ("Government Agencies") | NonProfit ("Non-profit") <- "Who are your customers? ($)"
        |int numberOfEmployees = min: 0 <- "How many employees you have?"
        |bool personalGuarantee <- "Do you have personal guarantee?"
        |
        |when
        | netProfit > 0
        |then
        | DTI = loanAmount / netProfit
        |
        |fact
        | LTV = loanAmount / collateralValue
        |
        |when
        | DTI < 0.2
        |then
        | DTIScore = 100.0
        |
        |when
        | DTI >= 0.2
        |then
        | DTIScore = 20.0 / DTI
        |
        |when
        | LTV < 0.2
        |then
        | LTVScore = 100.0
        |
        |when
        | LTV >= 0.2
        |then
        | LTVScore = 20.0 / LTV
        |
        |when
        | personalGuarantee
        |then
        | personalGuaranteeScore = 100
        |
        |when
        | !personalGuarantee
        |then
        | personalGuaranteeScore = 0
        |
        |when
        | useOfFounds == "PurchaseExistingBusiness"
        |then
        | useOfFoundsScore = 100
        |
        |when
        | useOfFounds == "PurchaseSellInventory" || useOfFounds == "FinanceReceivables"
        |then
        | useOfFoundsScore = 85
        |
        |when
        | cashBalance <= 10000
        |then
        | cashBalanceScore = 20
        |
        |when
        | cashBalance > 10000
        |then
        | cashBalanceScore = 100
        |
        |when
        | netProfit < grossSales
        | grossSales > 0
        |then
        | salesProfitScore = (100*netProfit) / grossSales
        |
        |when
        | netProfit > 10000
        |then
        | netProfitScore = 95
        |
        |when
        | customerType == "GovernmentAgencies"
        |then
        | customerTypeScore = 100
        |
        |when
        | customerType == "NonProfit"
        |then
        | customerTypeScore = 100
        |
        |when
        | customerType == "SmallBusiness"
        |then
        | customerTypeScore = 50
        |
        |when
        | numberOfEmployees <= 20
        |then
        | numberOfEmployeesScore = numberOfEmployees*5
        |
        |when
        | numberOfEmployees > 20
        |then
        | numberOfEmployeesScore = 100
        |
        |fact
        | finProfileWeight = 0.3
        | creditStatsWeight = 0.2
        | businessProfileWeight = 0.3
        | personalGuaranteeWeight = 0.2
        |
        |
        |fact
        | userScore = ((salesProfitScore + cashBalanceScore)/2.0)*finProfileWeight +  ((useOfFoundsScore + DTIScore + LTVScore)/3.0)*creditStatsWeight + ((customerTypeScore + numberOfEmployeesScore)/2.0)*businessProfileWeight + personalGuaranteeScore*personalGuaranteeWeight
        |
        |when
        | userScore > 50
        |then
        | res = "Accept"
        |
        |find userScore""".stripMargin, null, new ConsoleUserInteraction)
    println(new FCFInferenceEngine().run(input))
  }
}
