package net.sf.brunneng.fusie.examples

import net.sf.brunneng.fusie.input.pdl.PDLParser
import net.sf.brunneng.fusie.ui.ConsoleUserInteraction
import net.sf.brunneng.fusie.engine.fcf.FCFInferenceEngine

/**
 * User: goodg_000
 * Date: 14.05.13
 * Time: 22:27
 */
object ProgrammingLanguageAdviser {
  def main(args: Array[String]) {
    val input = new PDLParser().parseProblem(
      """int mainstream = min: 0 max: 5 <- "Should language be mainstream?"
        |int performance = min: 0 max: 5 <- "Should language have high execution performance?"
        |int richFeatures = min: 0 max: 5 <- "Should language have rich set of features?"
        |int instruments = min: 0 max: 5 <- "Should language have rich instruments set for programming?"
        |int easy = min: 0 max: 5 <- "Should language be easy for not experienced programmers?"
        |bool multyplatform <- "Should language be applicable for different OS and devices?"
        |bool writingScripts <- "Do you want writing scripts on this language?"
        |
        |when
        | mainstream <= 1
        | performance <= 2
        | instruments <= 4
        | easy <= 1
        |then
        | language = "scala"
        |
        |when
        | performance <= 4
        | richFeatures <= 3
        | !writingScripts
        |then
        | language = "java"
        |
        |when
        | mainstream <= 4
        | performance <= 4
        | richFeatures <= 4
        | easy <= 4
        | !multyplatform
        | !writingScripts
        |then
        | language = "C#"
        |
        |when
        | instruments <= 4
        | easy <= 2
        | !writingScripts
        |then
        | language = "C++"
        |
        |when
        | mainstream <= 2
        | performance <= 2
        | richFeatures <= 3
        | instruments <= 3
        | easy <= 4
        | writingScripts
        |then
        | language = "Perl"
        |
        |find language""".stripMargin, null, new ConsoleUserInteraction)
    println(new FCFInferenceEngine().run(input))
  }
}
