package net.sf.brunneng.fusie.input

import net.sf.brunneng.fusie.engine.VariableValuesSource
import scala.collection.mutable
import net.sf.brunneng.fusie.core.Variable

/**
 * User: goodg_000
 * Date: 04.05.13
 * Time: 19:31
 */
class HashMapValuesSource(val values: Map[String, Object]) extends VariableValuesSource {

  private val readVariables: mutable.Set[String] = new mutable.HashSet[String]

  def read[T](v: Variable[T]): T = {
    if (readVariables.contains(v.varName)) {
      throw new Exception("Variable " + v.varName + " was read second time")
    }

    readVariables += v.varName
    values(v.varName).asInstanceOf[T]
  }
}
