package net.sf.brunneng.fusie.input.functions

import java.util

/**
 * User: goodg_000
 * Date: 22.05.13
 * Time: 19:28
 */
class FunctionSignature(val name: String, val parameterTypes: Array[Class[_]]) {

  override def hashCode(): Int = name.hashCode + 31*parameterTypes.hashCode()

  override def equals(obj: Any): Boolean = {
    if (!obj.isInstanceOf[FunctionSignature]) return false

    val otherSignature = obj.asInstanceOf[FunctionSignature]
    return name.equals(otherSignature.name) &&
      util.Arrays.equals(
        parameterTypes.asInstanceOf[Array[AnyRef]],
        otherSignature.parameterTypes.asInstanceOf[Array[AnyRef]])
  }

  override def toString: String = name + "(" + parameterTypes + ")"
}
