package net.sf.brunneng.fusie.ui

import scala.collection.mutable
import java.util.Scanner

/**
 * User: goodg_000
 * Date: 02.05.13
 * Time: 18:42
 */
class ConsoleUserInteraction extends UserInteraction {
  def readValue(question: String, variants: List[String]): String = {
    println(question)

    var variantsMap: mutable.Map[String, String] = null
    if (variants != null) {
      variantsMap = new mutable.HashMap[String, String]
      var i = 1
      variants.foreach(v => {
        variantsMap(i.toString) = v
        variantsMap(v.trim) = v
        i += 1
      })
    }

    //val s = new Scanner(System.in)
    var input = readLine()
    if (variants != null) {
      var stopRepeat = false
      while (!stopRepeat) {
        input = variantsMap.getOrElse(input.trim, null)
        if (input == null) {
          println("Incorrect value. Please enter value from list or it ordinal number from 1 to " + variants.size + ".")
          input = readLine()
        }
        else {
          stopRepeat = true
        }
      }
    }

    input
  }

  def showError(errorMessage: String) {
    println("ERROR: " + errorMessage)
  }
}
