package net.sf.brunneng.fusie.core.expressions.fuzzy

import scala.collection.mutable.ListBuffer
import net.sf.brunneng.fusie.core.{Environment, Context, Variable}
import net.sf.brunneng.fusie.core.expressions.{VariableExpression, F2ExpressionFactory, Expression}

/**
 * Created with IntelliJ IDEA.
 * User: evvo
 * Date: 5/29/13
 * Time: 10:09 AM
 * To change this template use File | Settings | File Templates.
 */
class FuzzyBooleanExpression(val expr : Expression[Double]) extends Expression[Boolean] {

  var probabilityContext: Context = null
  var probabilityVariable: Variable[Boolean] = null

  def calculate: Boolean = {
    expr.calculate > 0
  }

  def getId = this.toString

  def collectVariables(res: ListBuffer[Variable[Any]]) {
    expr.collectVariables(res)
  }

  def getChildExpressions: List[Expression[Any]] = expr.getChildExpressions

  def reInitProbabilityVariable() {
    probabilityVariable = new Variable[Boolean](getId, classOf[Boolean])
    val env = new Environment
    env.pushContext(probabilityContext)
    env.set(probabilityVariable.varName, expr.calculate)
    probabilityVariable.env = env
  }

  def getProbabilityExpression: Expression[Boolean] = {
    if (!probabilityContext.contains(getId)) {
      reInitProbabilityVariable()
    }

    F2ExpressionFactory.andNullSafe(new VariableExpression[Boolean](probabilityVariable), expr.getProbabilityExpression)
  }
}
