package net.sf.brunneng.fusie.core.expressions.fuzzy

import net.sf.brunneng.fusie.core.expressions.Expression

/**
 * User: goodg_000
 * Date: 29.05.13
 * Time: 20:47
 */
class LinearMembershipFunction(testExpression: Expression[Double],
                               probabilitySource: MembershipFunctionProbabilitySource,
                               args: List[Expression[Double]])
  extends AbstractMembershipFunction(testExpression, "linear", probabilitySource, args) {

  def calculateInternal(value: Double, probabilityToValueData: Array[(Double, Double)]): Double = {
    var i = 0

    while (probabilityToValueData.size > i && probabilityToValueData(i)._2 <= value) {
      i += 1
    }

    if (i == 0)
      probabilityToValueData.head._1
    else if (i == probabilityToValueData.size)
      probabilityToValueData.last._1
    else {
      val leftPair = probabilityToValueData(i-1)
      val rightPair = probabilityToValueData(i)

      val p1 = leftPair._1
      val p2 = rightPair._1
      val v1 = leftPair._2
      val v2 = rightPair._2

      p1 + (p2 - p1)*((value - v1) / (v2 - v1))
    }
  }
}
