package net.sf.brunneng.fusie.core.expressions.fuzzy

import MembershipFunctionShapePartType._

/**
 * Created with IntelliJ IDEA.
 * User: evvo
 * Date: 5/29/13
 * Time: 4:59 PM
 * To change this template use File | Settings | File Templates.
 */
class MembershipFunctionProbabilitySource(val shape: List[MembershipFunctionShapePartType]) {

  def getProbability(pointIndex: Int): Double = {
    var i = 0

    var prevPartType: MembershipFunctionShapePartType = null
    var oneTypePartsCountForTargets = 0
    var consecutiveOneTypePartsCount = 1
    val shapeIterator = shape.iterator
    var stopSearch = false
    while (!stopSearch && i < shape.size) {
      val currPartType = shapeIterator.next()

      if (prevPartType != currPartType) {
        if (pointIndex < i) {
          stopSearch = true
        }
        else {
          consecutiveOneTypePartsCount = 1
        }
      }
      else {
        consecutiveOneTypePartsCount += 1
      }

      if (i == pointIndex) {
        oneTypePartsCountForTargets = consecutiveOneTypePartsCount
      }

      if (!stopSearch) {
        prevPartType = currPartType
      }

      i += 1
    }

    var notInEnd = 1
    if (pointIndex >= shape.size) {
      oneTypePartsCountForTargets = consecutiveOneTypePartsCount
      notInEnd = 0
    }

    val pos = (oneTypePartsCountForTargets - notInEnd).toDouble/consecutiveOneTypePartsCount
    prevPartType match {
      case MembershipFunctionShapePartType.GROWTH => pos
      case MembershipFunctionShapePartType.DECREASE => 1.0 - pos
    }
  }
}
