package net.sf.brunneng.fusie.core.expressions.fuzzy

import net.sf.brunneng.fusie.core.expressions.Expression
import org.apache.commons.math.analysis.polynomials.PolynomialFunctionLagrangeForm

/**
 * Created with IntelliJ IDEA.
 * User: evvo
 * Date: 5/30/13
 * Time: 10:55 AM
 * To change this template use File | Settings | File Templates.
 */
class PolynomialMembershipFunction(testExpression: Expression[Double],
                                   probabilitySource: MembershipFunctionProbabilitySource,
                                   args: List[Expression[Double]])
  extends AbstractMembershipFunction(testExpression, "poly", probabilitySource, args) {

  def calculateInternal(value: Double, probabilityToValueData: Array[(Double, Double)]): Double = {
    var i = 0

    while (probabilityToValueData.size > i && probabilityToValueData(i)._2 <= value) {
      i += 1
    }

    if (i == 0)
      probabilityToValueData.head._1
    else if (i == probabilityToValueData.size)
      probabilityToValueData.last._1
    else {
      val x = probabilityToValueData.map(p => p._2)
      val y = probabilityToValueData.map(p => p._1)
      val poly = new PolynomialFunctionLagrangeForm(x, y)
      poly.value(value)
    }
  }
}
